import { getBabelChain } from "@modern-js/babel-preset-lib";
import { getBuildInPlugins } from "./built-in";
const getBabelConfig = (modulePresetOption, syntaxOption) => {
  const chain = getModuleBabelChain(modulePresetOption, syntaxOption);
  return {
    sourceType: "unambiguous",
    ...chain.toJSON()
  };
};
const getModuleBabelChain = (modulePresetOption, syntaxOption) => {
  const chain = getBabelChain(modulePresetOption, syntaxOption);
  chain.plugin("@babel/plugin-proposal-do-expressions").use(require.resolve("@babel/plugin-proposal-do-expressions"));
  chain.plugin("@babel/plugin-proposal-throw-expressions").use(require.resolve("@babel/plugin-proposal-throw-expressions"));
  chain.plugin("@babel/plugin-proposal-class-static-block").use(require.resolve("@babel/plugin-proposal-class-static-block"));
  chain.plugin("@babel/plugin-proposal-function-sent").use(require.resolve("@babel/plugin-proposal-function-sent"));
  const buildInPlugins = getBuildInPlugins({
    importStyle: modulePresetOption.importStyle,
    staticDir: modulePresetOption.staticDir,
    styleDir: modulePresetOption.styleDir,
    sourceDir: modulePresetOption.sourceDir
  });
  chain.merge(buildInPlugins);
  return chain;
};
const getFinalBabelConfig = (chain) => ({
  sourceType: "unambiguous",
  ...chain.toJSON()
});
export * from "./types";
import { applyUserBabelConfig } from "@modern-js/utils";
export {
  applyUserBabelConfig,
  getBabelConfig,
  getFinalBabelConfig,
  getModuleBabelChain
};
